﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using DataBinding.Validators;
using NUnit.Framework;

namespace BSM.Tests
{
    [TestFixture]
    class JobTitleValidatorTest
    {
        IValidator<string> testSubject;

        [SetUp]
        public void SetUp()
        {
            testSubject = new JobTitleValidator(new String[]{"AA", "BB"});
        }

        [Test]
        public void TestMaxLength()
        {
            string valid = "1234567890123456789012345678901234567890"; //40 charachters
            string invalid = "12345678901234567890123456789012345678901"; //41 characters

            Assert.IsTrue(testSubject.IsValid(valid));
            Assert.IsFalse(testSubject.IsValid(invalid));
        }

        [Test]
        public void TestEmpty()
        {
            string valid = "as";
            string invalid = "";

            Assert.IsTrue(testSubject.IsValid(valid));
            Assert.IsFalse(testSubject.IsValid(invalid));
        }

        [Test]
        public void TestCaseInsensitiveInvalidValueList()
        {
            string valid = "a";
            string invalid = "aA";

            Assert.IsTrue(testSubject.IsValid(valid));
            Assert.IsFalse(testSubject.IsValid(invalid));
        }

        [Test]
        public void TestFileNameCharcters()
        {
            string valid = "_3@$g.Rga% asgd";

            Assert.IsTrue(testSubject.IsValid(valid));

            string invalid;
            char[] charList = System.IO.Path.GetInvalidFileNameChars();
            foreach(char c in charList)
            {
                invalid = "a" + c.ToString();
                Assert.IsFalse(testSubject.IsValid(invalid));
            }
        }
    }
}
