﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using BSM.core;

namespace BSM.Tests.Mocks
{
    class JobMock : JobBase
    {

        protected Status status;
        protected int callsToRun;


        public JobMock() : this(null)
        {
        }

        public JobMock(Status status)
            : base("JobMock")
        {
            this.status = status;
            this.callsToRun = 0;
        }

        public int CallsToRun
        {
            get { return callsToRun; }
        }

        public override Status Run()
        {
            callsToRun++;
            return this.status;
        }

        public override bool Configure(System.Windows.Forms.IWin32Window owner)
        {
            return false;
        }

        public override void Launch()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public override void DeleteSettings(string filePath)
        {
            
        }

        public override void LoadSettings(string filePath)
        {
            
        }

        public override void SaveSettings(string filePath)
        {
            
        }
    }
}
