﻿using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using BSM.core;
using System.IO;

namespace BSM.Tests
{
    [TestFixture]
    class PluginLoaderTest
    {
        [Test]
        public void TestCreatePluginFromType()
        {
            IPlugin plugin = PluginLoader.CreatePluginFromType(typeof(Mocks.PluginMock));

            Assert.AreEqual("mock", plugin.Name);
            Assert.IsNotNull(plugin.Icon);
            Assert.IsInstanceOf<Mocks.JobMock>(plugin.CreateInstance());
        }

        [Test]
        public void TestLoadOfItSelf()
        {
            string path = Path.GetDirectoryName(this.GetType().Assembly.Location);

            IDictionary<string, IPlugin> plugins = PluginLoader.Load(path);
            Assert.IsTrue(plugins.ContainsKey("mock"));
            Assert.IsNotNull(plugins["mock"]);
            Assert.IsInstanceOf<Mocks.JobMock>(plugins["mock"].CreateInstance());
        }
    }
}
