﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using BSM.core;

namespace BSM.Tests
{
    [TestFixture]
    public class StatusTest
    {
        Status testSubject;

        [SetUp]
        public void SetUp()
        {
            testSubject = new Status();
        }

        /// <summary>
        /// Test Changed method by changing text property
        /// </summary>
        [Test]
        public void TestChangedText()
        {
            Status other = new Status();

            // Assert initial conditions are correct.
            Assert.AreEqual(other.Text, testSubject.Text);
            Assert.AreEqual(other.Code, testSubject.Code);

            // Method being tested
            Assert.IsFalse(testSubject.Changed(testSubject));

            // Change text
            other.Text = "some text";

            // Assert condition correct.
            Assert.AreNotEqual(other.Text, testSubject.Text);

            // Method being tested
            Assert.IsTrue(testSubject.Changed(other));
        }

        /// <summary>
        /// Test Changed method by changing code property
        /// </summary>
        [Test]
        public void TestChangedCode()
        {
            Status other = new Status();

            // Assert initial conditions are correct.
            Assert.AreEqual(other.Text, testSubject.Text);
            Assert.AreEqual(other.Code, testSubject.Code);

            // Method being tested
            Assert.IsFalse(testSubject.Changed(testSubject));

            // Change text
            other.Code = Status.StatusCode.Red;

            // Assert conditions correct.
            Assert.AreNotEqual(other.Code, testSubject.Code);

            // Method being tested
            Assert.IsTrue(testSubject.Changed(other));
        }
    }
}
