﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;

namespace BSM.core
{
    /// <summary>
    /// Attribute used to declare a plugin
    /// Can only be applied to classes
    /// </summary>
    [AttributeUsage(AttributeTargets.Class, AllowMultiple=true, Inherited=true)]
    public class PluginAttribute : System.Attribute
    {
        private string name;

        public string Name
        {
            get { return name; }
            set { name = value; }
        }
	
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="name">plugin name as displayed in BSM</param>
        public PluginAttribute(string name)
        {
            this.name = name;
        }
    }
}
