﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

namespace BSM.core
{
    public class BsmException : Exception
    {

        readonly int threadId;

        public BsmException(string message, Exception innerException)
            : base(message, innerException)
        {
            threadId = Thread.CurrentThread.ManagedThreadId;
        }

        public override string ToString()
        {
            return String.Format("Thread id: {0}, Message: {1}, Type: {2}, Method: {3}",
                this.threadId,
                this.Message,
                this.GetType().ToString(),
                this.TargetSite);
        }
    }
}
