﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;

namespace BSM
{
    public enum BsmMessageTypes
    {
        General,
        StartingScheduler,
        StoppingScheduler,
        Refresh,
        JobFinished,
        JobStatusChanged,
        Exception,
        UIException
    }

    class BsmMessage
    {
        private string jobTitle;
        private string title;
        private string text;
        private BsmMessageTypes messageType;
        private bool display;

        public BsmMessage(): 
            this(BsmMessageTypes.General)
        {
        }

        public BsmMessage(BsmMessageTypes messageType)
            : this("", "", "", messageType)
        {
        }

        public BsmMessage(string jobTitle, string title, string text, BsmMessageTypes messageType)
        {
            this.jobTitle = jobTitle;
            this.title = title;
            this.text = text;
            this.MessageType = messageType;
            this.display = false;
        }

        public string JobTitle
        {
            get { return jobTitle; }
            set { jobTitle = value; }
        }

        public string Title
        {
            get { return title; }
            set { title = value; }
        }

        public string Text
        {
            get { return text; }
            set { text = value; }
        }

        public BsmMessageTypes MessageType
        {
            get { return messageType; }
            set { messageType = value; }
        }

        public bool Display
        {
            get { return display; }
            set { display = value; }
        }

        override public string ToString()
        {
            return String.Format("Job: {0}, Title:{1}, Text: {2}, Type: {3}",
                jobTitle, title, text, messageType.ToString());
        }

    }
}
