﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using BSM.core;

namespace BSM
{
    /// <summary>
    /// Wrapper class used for Serialization of classes 
    /// that implemnt the IJob interface
    /// </summary>
    public class JobListing
    {
        private string title;
        private string typeName;
        private int runInterval;
        private bool displayInTray;
        private bool enabled;

        /// <summary>
        /// Default constructor
        /// used by the serialization mechanism
        /// </summary>
        public JobListing()
        {
            title = "";
            typeName = "";
            displayInTray = false;
            enabled = true;
        }

        /// <summary>
        /// Constructor
        /// Wrapps an job instance for serialization
        /// </summary>
        /// <param name="job"></param>
        /// <param name="displayInTray"></param>
        public JobListing(IJob job, bool displayInTray)
        {
            this.title = job.Title;
            this.typeName = job.TypeName;
            this.displayInTray = displayInTray;
            this.runInterval = job.RunIntervalInSeconds;
            this.enabled = job.Enabled;
        }

        [XmlAttribute("Title")]
        public string Title
        {
            get { return title; }
            set { title = value; }
        }

        [XmlAttribute("TypeName")]
        public string TypeName
        {
            get { return typeName; }
            set { typeName = value; }
        }

        [XmlAttribute("Enabled")]
        public bool Enabled
        {
            get { return enabled; }
            set { enabled = value; }
        }

        [XmlAttribute("RunInterval")]
        public int RunInterval
        {
            get { return runInterval; }
            set { runInterval = value; }
        }

        [XmlAttribute("DisplayInTray")]
        public bool DisplayInTray
        {
            get { return displayInTray; }
            set { displayInTray = value; }
        }

    }
}
