﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using DataBinding.Validators;

namespace BSM
{
    class JobTitleValidator : ExcludeArrayValidator<string>
    {
        public JobTitleValidator(string[] invalidJobTitles)
            : base(invalidJobTitles)
        {
            for (int i = 0; i < invalidValues.Length; i++ )
            {
                invalidValues[i] = invalidValues[i].ToUpper();
            }
        }

        public override bool IsValid(string value)
        {
            if (value == null)
                return false;

            if (value == String.Empty)
                return false;

            if (!base.IsValid(value.ToUpper()))
                return false;

            if (value.Length > 40)
                return false;

            if (value.IndexOfAny(System.IO.Path.GetInvalidFileNameChars()) != -1)
                return false;

            return true;
        }
    }
}
