﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using DataBinding.Validators;

namespace DataBindingTests.TestCases
{
    [TestFixture]
    class EmailValidatorTest
    {
        [Test]
        public void TestIsValid()
        {
            IValidator<string> testSubject = new EmailValidator();
            Assert.AreEqual(true, testSubject.IsValid("firstName@domain.com"));
            Assert.AreEqual(true, testSubject.IsValid("first.last@domain.com"));
            Assert.AreEqual(true, testSubject.IsValid("user123@domail.com"));
            Assert.AreEqual(true, testSubject.IsValid("user123@192.168.0.1"));
            Assert.AreEqual(true, testSubject.IsValid("first_last@192.168.0.1"));
            Assert.AreEqual(false, testSubject.IsValid(""));
            Assert.AreEqual(false, testSubject.IsValid("@domain.com"));
            Assert.AreEqual(false, testSubject.IsValid("first.last@"));
            Assert.AreEqual(false, testSubject.IsValid("user123@host"));
            Assert.AreEqual(false, testSubject.IsValid("user@host.tolong"));
        }
    }
}
