﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using DataBinding.Validators;

namespace DataBindingTests.TestCases
{
    [TestFixture]
    class ExcludeValueValidatorTest
    {

        [Test]
        public void TestString()
        {
            IValidator<string> testSubject = new ExcludeValueValidator<string>("invalid");

            Assert.AreEqual(true, testSubject.IsValid("some text"));
            Assert.AreEqual(true, testSubject.IsValid(""));
            Assert.AreEqual(true, testSubject.IsValid(null));
            Assert.AreEqual(false, testSubject.IsValid("invalid"));
        }

        [Test]
        public void TestDouble()
        {
            IValidator<double> testSubject = new ExcludeValueValidator<double>(20.0);

            Assert.AreEqual(true, testSubject.IsValid(20.1));
            Assert.AreEqual(true, testSubject.IsValid(0));
            Assert.AreEqual(false, testSubject.IsValid(20.0));
        }


        private enum Values
        {
            ValidValue,
            InvalidValue
        }

        [Test]
        public void TestEnum()
        {
            IValidator<Values> testSubject = new ExcludeValueValidator<Values>(Values.InvalidValue);

            Assert.AreEqual(true, testSubject.IsValid(Values.ValidValue));
            Assert.AreEqual(false, testSubject.IsValid(Values.InvalidValue));
        }
    }
}
