﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using DataBinding;
using NUnit.Framework;

namespace DataBindingTests.TestCases
{
    [TestFixture]
    public class GenericParserTest
    {
        [Test]
        public void TestParseFromStringToInt()
        {
            int value;
            Assert.AreEqual(true, GenericParser.Parse<string, int>("123", out value));
            Assert.AreEqual(123, value);

            Assert.AreEqual(true, GenericParser.Parse<string, int>("1", out value));
            Assert.AreNotEqual(123, value);

            Assert.AreEqual(false, GenericParser.Parse<string, int>("123g", out value));
            Assert.AreEqual(default(int), value);

        }

        [Test]
        public void TestParseFromDoubleToString()
        {
            string value;
            Assert.AreEqual(true, GenericParser.Parse<double, string>(10.23, out value));
            Assert.AreEqual((10.23).ToString(), value);

            Assert.AreEqual(true, GenericParser.Parse<double, string>(10.0, out value));
            Assert.AreNotEqual((10.23).ToString(), value);
        }

        private enum Values
        {
            Value0 = 0,
            Value12 = 12
        }

        [Test]
        public void TestParseFromIntToEnum()
        {
            Values enumVar;
            Assert.AreEqual(true, GenericParser.Parse<int, Values>(0, out enumVar));
            Assert.AreEqual(Values.Value0, enumVar);

            Assert.AreEqual(true, GenericParser.Parse<int, Values>(12, out enumVar));
            Assert.AreEqual(Values.Value12, enumVar);

            // This fails due to bad implementation in the CLI.
            // nothing to do really. Just remember it.
            //Assert.AreEqual(false, GenericParser.Parse<int, Values>(2, out enumVar));
            //Assert.AreEqual(Values.Value0, enumVar);
        }
    }
}
