﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using DataBinding.Validators;

namespace DataBindingTests.TestCases
{
    [TestFixture]
    class IsRegexValidatorTest
    {
        [Test]
        public void TestIsValid()
        {
            IValidator<string> testSubject = new IsRegexValidator();
            Assert.AreEqual(true, testSubject.IsValid(@"^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$"));
            Assert.AreEqual(true, testSubject.IsValid(@"^(s-|S-){0,1}[0-9]{3}\s?[0-9]{2}$"));
            Assert.AreEqual(true, testSubject.IsValid(""));
            Assert.AreEqual(false, testSubject.IsValid("[9-0]"));
        }
    }
}
