﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using NUnit.Framework;
using DataBinding.Validators;

namespace DataBindingTests.TestCases
{
    [TestFixture]
    class PostalCodeValidatorsTest
    {
        [Test]
        public void TestSwedishPostalCode()
        {
            IValidator<string> testSubject = new SwedishPostalCodeValidator();
            Assert.AreEqual(true, testSubject.IsValid("48321"));
            Assert.AreEqual(true, testSubject.IsValid("483 21"));
            Assert.AreEqual(true, testSubject.IsValid("S-48321"));
            Assert.AreEqual(true, testSubject.IsValid("S-483 21"));
            Assert.AreEqual(true, testSubject.IsValid("s-48321"));
            Assert.AreEqual(true, testSubject.IsValid("s-483 21"));
            Assert.AreEqual(false, testSubject.IsValid("4832111"));
            Assert.AreEqual(false, testSubject.IsValid("483 211"));
            Assert.AreEqual(false, testSubject.IsValid("4832"));
            Assert.AreEqual(false, testSubject.IsValid("483 2"));
            Assert.AreEqual(false, testSubject.IsValid("N-483 32"));
        }

        [Test]
        public void TestUSZip()
        {
            IValidator<string> testSubject = new USZipCodeValidator();
            Assert.AreEqual(true, testSubject.IsValid("12345"));
            Assert.AreEqual(true, testSubject.IsValid("12345-1234"));
            Assert.AreEqual(true, testSubject.IsValid("12345 1234"));
            Assert.AreEqual(true, testSubject.IsValid("123451234"));
            Assert.AreEqual(false, testSubject.IsValid("4832"));
            Assert.AreEqual(false, testSubject.IsValid("123456"));
            Assert.AreEqual(false, testSubject.IsValid("1234-1234"));
            Assert.AreEqual(false, testSubject.IsValid("1234 1234"));
            Assert.AreEqual(false, testSubject.IsValid("12345 123"));
            Assert.AreEqual(false, testSubject.IsValid("12345 12345"));
        }
    }
}
