﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace DataBinding.FormControlValidators
{
    public class ComboBoxIndexValidatorBase<T> : ComboBoxValidatorBase<T> where T : IComparable
    {

        public ComboBoxIndexValidatorBase(ComboBox comboBox,
            IDataField<T> dataField, string invalidValueMessage)
            : base(comboBox, dataField, invalidValueMessage)
        {
            int index;
            this.valid = GenericParser.Parse<T, int>(dataField.Value, out index);
            comboBox.SelectedIndex = index;
        }

        override protected void UpdateAndValidateValue()
        {
            T value;
            this.valid = GenericParser.Parse<int, T>(comboBox.SelectedIndex, out value);
            if (this.valid)
            {
                base.UpdateAndValidateValue(value);
            }
            else // parse failed, revert to last valid value
            {
                ReverseUpdateAndValidateValue();
            }
        }

        protected override void ReverseUpdateAndValidateValue()
        {
            int index;
            this.valid = GenericParser.Parse<T, int>(dataField.Value, out index);
            comboBox.SelectedIndex = index;
            base.ValidateValue();
        }
    }
}
