﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace DataBinding.FormControlValidators
{
    public class ComboBoxIndexValidatorColor<T> : ComboBoxIndexValidatorBase<T> where T : IComparable
    {
        private Color defaultForeColor;
        private Color invalidDataColor;

        public ComboBoxIndexValidatorColor(ComboBox comboBox, IDataField<T> dataField, 
            string invalidValueMessage, Color invalidDataColor)
            : base(comboBox, dataField, invalidValueMessage)
        {
            this.defaultForeColor = comboBox.ForeColor;
            this.invalidDataColor = invalidDataColor;
        }

        override protected void ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            base.ComboBox_SelectedIndexChanged(sender, e);
            comboBox.ForeColor = (this.valid) ? defaultForeColor : invalidDataColor;
        }

        override public void Dispose()
        {
            base.Dispose();
            this.comboBox.ForeColor = defaultForeColor;
        }
    }
}
