﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 19, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace DataBinding.FormControlValidators
{
    public class DateTimePickerValidatorDisplayLabel : DateTimePickerValidatorBase
    {
        private Label warningLabel;

        public DateTimePickerValidatorDisplayLabel(DateTimePicker control,
            IDataField<DateTime> dataField, string invalidValueMessage,
            Label warningLabel)
            :
            base(control, dataField, invalidValueMessage)
        {
            this.warningLabel = warningLabel;
        }

        override protected void Control_ValueChanged(object sender, EventArgs e)
        {
            base.Control_ValueChanged(sender, e);
            this.warningLabel.Visible = !this.valid;
        }

        override public void Dispose()
        {
            base.Dispose();
            this.warningLabel.Visible = false;
        }
    }
}
