﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace DataBinding.FormControlValidators
{
    public class TextBoxValidatorBase<T> : ControlTextValidatorBase<T> where T: IComparable
    {
        public TextBoxValidatorBase(TextBoxBase textBox, IDataField<T> dataField,
            string invalidValueMessage)
            :
            base(textBox, dataField, invalidValueMessage)
        {
        }

        override public bool Validate()
        {
            UpdateAndValidateValue();
            if (!this.valid)
            {
                ((TextBoxBase)control).SelectAll();
                control.Focus();
            }
            return this.valid;
        }
    }
}
