﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace DataBinding.FormControlValidators
{
    public class TextBoxValidatorColor<T> : TextBoxValidatorBase<T> where T : IComparable
    {
        private Color defaultForeColor;
        private Color invalidDataColor;

        public TextBoxValidatorColor(TextBoxBase textBox, IDataField<T> dataField, 
            string invalidValueMessage, Color invalidDataColor)
            : base(textBox, dataField, invalidValueMessage)
        {
            this.defaultForeColor = textBox.ForeColor;
            this.invalidDataColor = invalidDataColor;
        }

        override protected void Control_TextChanged(object sender, EventArgs e)
        {
            base.Control_TextChanged(sender, e);
            control.ForeColor = (this.valid) ? defaultForeColor : invalidDataColor;
        }

        override public void Dispose()
        {
            base.Dispose();
            control.ForeColor = defaultForeColor;
        }

    }
}
