﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;

namespace DataBinding
{
    public class GenericParser
    {
        static public bool Parse<InputType, OutputType>(InputType input, out OutputType output)
        {
            output = default(OutputType);
            try // try conversion
            {
                
                output = (OutputType)Convert.ChangeType(input, typeof(OutputType));
                return true;
            }
            catch
            {
                // do nothing, try next thing
            }

            try // and if that doesn't work, try cast boxed/unboxed through object
            {
                output = (OutputType)(object)input;
                return true;
            }
            catch
            {
                // do nothing
            }

            return false;
        }
    }
}
