﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;

namespace DataBinding.Matchers
{
    /// <summary>
    /// Generic matcher. Is a match if values are equal using Equals()
    /// </summary>
    public class EqualMatcher<T> : IMatcher<T>
    {
        public bool IsMatch(T value, T searchValue)
        {
            return (value != null && searchValue != null) ?
                value.Equals(searchValue) :
                false;
        }
    }
}
