﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using DataBinding.Validators;

namespace DataBinding.Validators
{
    /// <summary>
    /// Validates email address.
    /// </summary>
    public class EmailValidator : IValidator<string>
    {
        virtual public bool IsValid(string value)
        {
            // Based on a Regex found at:
            // http://msdn.microsoft.com/en-us/library/01escwtf%28VS.71%29.aspx
            Regex emailRegex = new Regex(@"^([\w-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([\w-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$");
            return emailRegex.IsMatch(value);
        }
    }
}
