﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: August 1, 2009
// Last modified: August 1, 2009
//**********************************//
using System;
using System.Collections.Generic;
using System.Text;

namespace DataBinding.Validators
{
    /// <summary>
    /// Generic validator.
    /// Will fail validation if value is equal to any value in the array
    /// registered in the constructor
    /// </summary>
    public class ExcludeArrayValidator<T> : IValidator<T>
    {
        protected T[] invalidValues;

        public ExcludeArrayValidator(T[] invalidValues)
        {
            this.invalidValues = new T[invalidValues.Length];
            invalidValues.CopyTo(this.invalidValues, 0);
        }

        virtual public bool IsValid(T value)
        {
            if (value == null)
                return true;

            foreach (T invalidValue in invalidValues)
            {
                if (invalidValue.Equals(value))
                    return false;
            }

            return true;
        }
    }
}
