﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;

namespace DataBinding.Validators
{
    /// <summary>
    /// Generic validator.
    /// Will fail validation if value is equal to the invalid value
    /// registered in the constructor
    /// </summary>
    public class ExcludeValueValidator<T> : IValidator<T>
    {
        private T invalidValue;

        public ExcludeValueValidator(T invalidValue)
        {
            this.invalidValue = invalidValue;
        }
        
        virtual public bool IsValid(T value)
        {
            if (value == null)
                return true;
            if (value.Equals(invalidValue))
                return false;

            return true;
        }
    }
}
