﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: August 1, 2009
// Last modified: August 1, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;

namespace DataBinding.Validators
{
    /// <summary>
    /// Generic validator.
    /// Will fail validation if value is equal to the invalid value
    /// registered in the constructor
    /// </summary>
    public class MultiValidator<T> : IValidator<T>
    {
        private IValidator<T>[] validators;

        public MultiValidator(IValidator<T>[] validators)
        {
            this.validators = validators;
        }

        virtual public bool IsValid(T value)
        {
            foreach (IValidator<T> validator in validators)
            {
                if (!validator.IsValid(value))
                    return false;
            }

            return true;
        }
    }
}
