﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace DataBinding.Validators
{
    /// <summary>
    /// Validates swedish postal code format ### ## or #####
    /// </summary>
    public class SwedishPostalCodeValidator : IValidator<string>
    {
        virtual public bool IsValid(string postalCode)
        {
            // Based on a regex found at:
            // http://www.java2s.com/Code/Java/Regular-Expressions/MatchZip.htm
            Regex postalCodeRegex = new Regex(@"^(s-|S-){0,1}[0-9]{3}\s?[0-9]{2}$");
            return postalCodeRegex.IsMatch(postalCode);
        }
    }
}
