﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 11, 2009
// Last modified: July 23, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;

namespace DataBinding.Validators
{
    /// <summary>
    /// Validates US Zip Code format
    /// ##### or #####-#### or ##### ####
    /// </summary>
    public class USZipCodeValidator : IValidator<string>
    {
        virtual public bool IsValid(string postalCode)
        {
            // Based on a Regex found at:
            // http://www.java2s.com/Code/Java/Regular-Expressions/MatchZip.htm
            Regex postalCodeRegex = new Regex(@"^\d{5}(-)?\s?(?:\d{4})?$");
            return postalCodeRegex.IsMatch(postalCode);
        }
    }
}