﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Net;

using NUnit.Framework;
using DataBinding;
using DataBinding.FormControlValidators;

namespace Hudson.Tests
{
    [TestFixture]
    public class ComboboxValidatorWithAuthenticationMethod
    {
        [Test]
        public void Test()
        {
            ComboBox cmb = new ComboBox();
            string[] options = Enum.GetNames(typeof(HudsonSettings.AuthenticationMethods));
            foreach (string opt in options)
            {
                cmb.Items.Add(opt);
            }
            cmb.SelectedIndex = (int)HudsonSettings.AuthenticationMethods.None;
            DataField<HudsonSettings.AuthenticationMethods> field = new DataField<HudsonSettings.AuthenticationMethods>(
                null, null, HudsonSettings.AuthenticationMethods.None);

            IFormControlValidator validator = new ComboBoxIndexValidatorColor<HudsonSettings.AuthenticationMethods>(
                cmb, field, "", System.Drawing.Color.Red);

            Assert.AreEqual(cmb.SelectedIndex, (int)field.Value);
            Assert.IsTrue(validator.Validate());

            cmb.SelectedIndex = (int)HudsonSettings.AuthenticationMethods.Basic;
            Assert.AreEqual(cmb.SelectedIndex, (int)HudsonSettings.AuthenticationMethods.Basic);
            Assert.AreEqual(cmb.SelectedIndex, (int)field.Value);
            Assert.IsTrue(validator.Validate());
     

        }
    }
}
