﻿//**********************************//
// Written by: Per Böhlin
// perbo770@student.liu.se
// Copyright: (c) 2009
//
// Implementation started: July 27, 2009
// Last modified: August 12, 2009
//**********************************//

using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using NUnit.Framework;
using BSM.core;

namespace Hudson.Tests
{
    [TestFixture]
    class HudsonJobTest
    {
        [Test]
        public void TestRunMethodNoneThreaded()
        {
            
            HudsonSettings settings = new HudsonSettings();
            settings.UrlFeed = Properties.Settings.Default.URLToMockRSS;
            settings.Timeout = Properties.Settings.Default.TimeOut;
            HudsonJob job = new HudsonJob(settings);
            job.RunIntervalInSeconds = 300;
            job.Title = "Test";

            Status state = job.Run();

            Assert.AreNotEqual(Status.StatusCode.Unknown, state.Code);

        }

        [Test]
        public void TestRunMethodCallMultipleTimes()
        {
            HudsonSettings settings = new HudsonSettings();
            settings.UrlFeed = Properties.Settings.Default.URLToMockRSS;
            settings.Timeout = Properties.Settings.Default.TimeOut;
            HudsonJob job = new HudsonJob(settings);
            job.RunIntervalInSeconds = 300;
            job.Title = "Test";

            Status stateFirstRun = job.Run();

            Assert.AreNotEqual(Status.StatusCode.Unknown, stateFirstRun.Code);

            Thread.Sleep(1000);

            Status stateSecondRun = job.Run();

            Assert.AreNotSame(stateFirstRun, stateSecondRun);
            Assert.AreNotEqual(stateFirstRun, stateSecondRun);

        }
    }
}
